#!/usr/bin/env python
#! -*- coding: utf-8 -*-
import sys
import subprocess
import commands
import os
import shutil
import gettext
try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
except:
	sys.exit(1)
try:
	subprocess.call("qrencode")
	print "qrencode is installed"
except:
	err=gtk.MessageDialog(parent=None, flags=0, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_CLOSE, 
	message_format="Package 'qrencode' has to be installed!")
	err.run()
	err.destroy()
	sys.exit(1)	
class qr_maker():
	def __init__(self):
		def exit(widget):
			print "Program is going down..."
			self.window.destroy()
			sys.exit(1)	
		def typ(choice):
			self.qr_volba=choice
			print self.qr_volba
			return self.qr_volba
		def set_type(widget, type):
			buffer=text_entry.get_buffer()
			start,end=buffer.get_bounds()
			self.type=type
			print self.type," was chosen."
			if self.type =="url":
				if buffer.get_text(start,end, gtk.TRUE)[:7]=="http://":
					buffer.set_text(buffer.get_text(start,end, gtk.TRUE)[7:])
				else:
					text="http://"+buffer.get_text(start,end, gtk.TRUE)
					buffer.set_text(text)
				number_label.set_text(number_label.get_text().split(".")[0]+".")
			if self.type == "text":
				number_label.set_text(number_label.get_text().split(".")[0]+".")
			if self.type =="phone":
				number_label.set_text(number_label.get_text()+_(" Only numbers allowed. "))
				if buffer.get_text(start,end, gtk.TRUE)[:7]=="http://":
					buffer.set_text(buffer.get_text(start,end, gtk.TRUE)[7:])
			return typ(type)
			
			
		def count_entered_input(widget):
			buffer=text_entry.get_buffer()
			start,end=buffer.get_bounds()
			count=len(text_entry.get_buffer().get_text(start,end, gtk.TRUE))
			if count > 250:
				buffer.set_text(buffer.get_text(start,end, gtk.TRUE)[0:250])
			else:
				if self.qr_volba !="phone":
					number_label.set_text(str(250-count)+_(" characters left. "))
				else:
					number_label.set_text(str(250-count)+_(" characters left. Only numbers allowed. "))
			
			
		def zmena_seznam(combobox):
				model=combobox.get_model()
				index=combobox.get_active()
				if index > -1:
					print model[index][0], 'selected'
				print self.spinbutton1.get_value_as_int()			
		def generate(pixel_size, input_text, qr_type):
			if qr_type=="phone":
				input_text="TEL:"+input_text
			model=combobox.get_model()
			index=combobox.get_active()
			correction_level=model[index][0]
			#subprocess.call("qrencode", "-o", "/tmp/qr.png", "-s", str(pixel_size), " -l", correction_level, input_text, shell=True)
			print "qrencode -o /tmp/qr.png -s "+str(pixel_size)+ " -l "+ correction_level+" "+ input_text
			subprocess.call(["qrencode -o /tmp/qr.png -s "+str(pixel_size)+ " -l "+ correction_level+" '"+ input_text+"'"], shell=True)
			image.set_from_file("/tmp/qr.png")
			save_button.set_sensitive(True)
			upload_button.set_sensitive(True)
			upload_button.connect("clicked", self.upload, "/tmp/qr.png")
			
		def prepair_generation(widget):
			print "volba ", self.qr_volba
			buffer=text_entry.get_buffer()
			start,end=buffer.get_bounds()
			text=buffer.get_text(start,end, gtk.TRUE)

			if text=="":
				err=gtk.MessageDialog(parent=None, flags=0, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_OK, 
				message_format=_("Can't generate empty string!"))
				err.run()
				err.destroy()
				image.set_from_file(gtk-missing-image)
			else:
				check=True
				if self.qr_volba == "phone":
					for i in text:
						if i not in "+-0123456789":
							err=gtk.MessageDialog(parent=None, flags=0, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_OK, 
							message_format=_("Entered symbols must be in '+-0123456789'"))
							err.run()
							err.destroy()
							check=False
							break
						
				if check==True:
					return generate(self.spinbutton1.get_value_as_int(),text, self.qr_volba) 
				
		def save(self):
			path = os.getenv("HOME")
			self.dialog = gtk.FileChooserDialog(title=_("Save file..."), action=gtk.FILE_CHOOSER_ACTION_SAVE, buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_SAVE,gtk.RESPONSE_OK))
			self.dialog.set_current_folder(path)
			filter=gtk.FileFilter()
			filter.set_name("PNG images (.png)")
			filter.add_pattern(".png")	
			response = self.dialog.run()
			if response == gtk.RESPONSE_OK:
				if self.dialog.get_filename().split(".")[-1] != "png":
					name = self.dialog.get_filename() + ".png"
				else:
					name = self.dialog.get_filename()
				shutil.copyfile("/tmp/qr.png", name)
				print "File was correctly saved."
				self.dialog.destroy()
			else:
				print "File wasn't saved."
				self.dialog.destroy()
		# Add translation files
		root="locales"
		t = gettext.translation("qr-maker", root)
		_ = t.ugettext
		t.install()				
				
		self.gladefile = "qr_maker.glade"  
		self.wTree = gtk.glade.XML(self.gladefile) 
		text_entry=self.wTree.get_widget("textview1")

		self.window = self.wTree.get_widget("window1")
		self.window.set_title("GTK QR Maker")
		url_check=self.wTree.get_widget("radiocheck_url")
		url_check.set_label(_("URL"))
		text_check=self.wTree.get_widget("radiocheck_text")
		text_check.set_label(_("Text"))
		phone_check=self.wTree.get_widget("radiocheck_phone")
		phone_check.set_label(_("Phone"))
		label=self.wTree.get_widget("number_label")
		label.set_label(_("250 characters left."))
		url_check.connect("toggled", set_type, "url")
		text_check.connect("toggled", set_type, "text")
		phone_check.connect("toggled", set_type, "phone")
		end_button=self.wTree.get_widget("exit_button")
		end_button.connect("clicked", exit)
		end_button.set_label(_("Exit"))
		save_button=self.wTree.get_widget("save_button")
		save_button.set_label(_("Save"))
		upload_button=self.wTree.get_widget("upload_button")
		save_button.connect("clicked", save)
		number_label=self.wTree.get_widget("number_label")
		generate_button=self.wTree.get_widget("generate_button")
		generate_button.set_label(_("Generate QR code!"))
		generate_button.connect("clicked", prepair_generation)
		frame_text=self.wTree.get_widget("Text")
		frame_text.set_label(_("Input text"))
		text_entry.get_buffer().connect('changed', count_entered_input)
		combobox=self.wTree.get_widget("combobox")
		combobox.connect("changed", zmena_seznam)
		combobox.set_active(0)
		correction_level_label=self.wTree.get_widget("label6")
		correction_level_label.set_text(_("Correction Level"))
		pixel_size_label=self.wTree.get_widget("label5")
		pixel_size_label.set_text(_("Pixel size"))
		output_frame=self.wTree.get_widget("label2")
		output_frame.set_text(_("Output QR"))
		image=self.wTree.get_widget("image")
		self.spinbutton1=self.wTree.get_widget("spin")
		self.window.show_all()
		set_type("widget", "url")
		save_button.set_sensitive(False)
		upload_button.set_sensitive(False)

        def run(self):

            gtk.main()

	def upload(self, widget, filename):
		def show_window(list):
			links=list
			print "SGSDG\n",links
			def quit(widget):
				links_window.destroy()
			gladefile2 = "qr_maker_ok.glade"  
			WTree = gtk.glade.XML(gladefile2) 
			links_window=WTree.get_widget("window1")
			links_window.set_title(_("GTK QR Maker - uploaded"))
			info_label=WTree.get_widget("label1")
			info_label.set_text(_("QR info:"))
			ok_button=WTree.get_widget("ok_button")
			ok_button.set_label(_("Exit"))
			ok_button.connect("clicked", quit)
			date_label=WTree.get_widget("date")
			date_label.set_text(_("Time and date of upload:"))
			size_label=WTree.get_widget("size")
			size_label.set_text(_("Picture size:"))
			link_label=WTree.get_widget("link")
			link_label.set_text(_("QR code link:"))
			delete_label=WTree.get_widget("delete")
			delete_label.set_text(_("Link to delete file:"))
			small_label=WTree.get_widget("small")
			small_label.set_text(_("Small thumbnail:"))
			large_label=WTree.get_widget("large")
			large_label.set_text(_("Large thumbnail:"))
			links_window.show_all()
			date_info_label=WTree.get_widget("date_info")
			date_info_label.set_text(links["datetime"])
			size_info_label=WTree.get_widget("size_info")
			size=links["width"]+" x "+links["height"]+" px"
			size_info_label.set_text(size)
			link_address_label=WTree.get_widget("link_address")
			link_address_label.set_text(links["original"])
			delete_address_label=WTree.get_widget("delete_address")
			delete_address_label.set_text(links["delete_page"])
			small_address_label=WTree.get_widget("small_address")
			small_address_label.set_text(links["small_square"])
			large_address_label=WTree.get_widget("large_address")
			large_address_label.set_text(links["large_thumbnail"])
			links_window.show_all()
		import urllib
		import urllib2
		print "File "+filename
		connection=True
		try:
			urllib2.urlopen('http://google.com')
		except:
			err=gtk.MessageDialog(parent=None, flags=0, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_CLOSE, 
			message_format="Internet connection is required if you want upload QR code to the internet!")
			err.run()
			err.destroy()
			connection=False
		if connection==True:
			import urllib
			import urllib2
			import base64
			from xml.etree import ElementTree
			tags=[]
			values=[]
			list={}
			picture = open(filename)
			picture2=picture.read()
			encoded_picture=base64.b64encode(picture2)
			print encoded_picture
			url = 'http://api.imgur.com/2/upload'
			parameters = {'key' : '02b62fd8f1d5e78321e62bb42ced459e', 'image' : encoded_picture}
			data = urllib.urlencode(parameters)
			req = urllib2.Request(url, data)
			response = urllib2.urlopen(req)
			element=ElementTree.XML(response.read())
			for i in element:
				for b in i:
					tags.append(b.tag)
					values.append(b.text)
			a=0
			for i in tags:
				list[tags[a]]=values[a]
				a=a+1
			return show_window(list)
		else:
			print "You are not connected to the internet!"
			return
			
if __name__ == "__main__" :

    application = qr_maker()
    application.run()
